import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import javax.swing.*;
import java.io.*; //Paquete para la administrasción de archivos
import java.util.*;
/**
 * Write a description of class Revision here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Solucion extends Actor
{
    private int nivel;
    private int nuevoNivel;
    private boolean ayuda = false;
    
    /**
     * Todas las etiquetas posibles a corregir 
     * del nivel uno
     */
    private htmlIni htmlIni;
    private htmlFin htmlFin;
    private headIni headIni;
    private headFin headFin;
    private bodyIni bodyIni;
    private bodyFin bodyFin;
    private texto texto;
    private br br;
    /**
     * Todas las etiquetas posibles a corregir del nivel Dos
     */
    private olFin olFin;
    private li3 li3;
    private li1 li1;
    private olIni olIni;
    private h1 h1;
    private li2 li2;
    private img img;
    /**
     * Todas las posibles etiquetas a corregir del nivel Tres
     */
    private input2 input2;
    private table table;
    private input3 input3;
    private formFin formFin;
    private input1 input1;
    private input4 input4;
    private formIni formIni;
    /**
     * Todas las posibles etiquetas a coorregir del nivel Cuatro
     */
    private divIni divIni;
    private span span;
    private selectIni selectIni;
    private option1 option1;
    private option2 option2;
    private option3 option3;
    private selectFin selectFin;
    private ifram iframe;
    /**
     * Todas las posibles etiquetas a corregir del nivel Cinco
     */
    private divFin divFin;
    
    private HtmlWorld world;
    private List correccion;
    
    /**
     * lista que se llena dependiendo del nivel en el que se encuentra
     */
    private List<String> listaDeTagsEnHoja;
    private boolean evaluaAhora = false;
    /**
     * lista que se evaluara es decir donde se quedo el usuario 
     */
    private List<String> listaEvalua; 

    /**
     * Constructor de Revision inicializa hW htmlWorld con la variable del mundo
     */
    public Solucion (HtmlWorld w)
    {
        world = w;
    }
    
    /**
     * Act - do whatever the Revision wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(evaluaAhora)
        {
            nivel = world.dameNivel();
            //Pide la lista Patron para saber la calificacion
            listaDeTagsEnHoja = world.dameListaDeTags();
            //Pide la lista que lleno el usuario
            listaEvalua = world.dameListaAEvaluar();
            evalua(listaDeTagsEnHoja,listaEvalua);
        }
        
    }   
    
    /**
     * Este método se encarga de evaluar al usuario y su avance para ver si es que puede aprobar el nivel o no
     * @<param> listaDebe es lo que debe tener el usuario
     * @<param> listaTiene es lo que tiene el usuario y se evaluara por eso.
     */
    public void evalua(List<String> listaDebe, List<String> listaTiene)
    {
        int i;
        //Si no ah ayudado antes entonces
        if(!ayuda)
        {
            for(i = 0; i < listaDebe.size(); i++)
            {
                if(listaTiene.indexOf(listaDebe.get(i)) == -1 && !ayuda) //Si se encuentra una etiqueta que se debe pero que no esta entonces ayuda
                { 
                    world.meteTagsEnLista(listaDebe.get(i));
                    agregaObjeto(listaDebe.get(i));
                    //que ponga musiquita 
                    ayuda = true;
                }
                else
                {   
                    //JOptionPane.showConfirmDialog(null, "Tu hoja esta completa ahora presiona el bóton Revisión \n para pasar de nivel", "Terminaste Nivel", JOptionPane.OK_CANCEL_OPTION ,JOptionPane.INFORMATION_MESSAGE);
                }
            }
            evaluaAhora = false;
            ayuda = false;
        }
    }    
    /**
     * Este metodo fue diseñado para que desde el contructor se pueda 
     * dar el banderazo para que se comience a evaluar cual solucion va a dar
     */
    public void comienza()
    {
        evaluaAhora = true;
    }
       
    /**
     * 
     */
    public void agregaObjeto(String tag)
    {
        switch(nivel)
        {
            case 1: //Correccion para el nivel uno
                if(tag.equals("htmlIni"))
                {
                    correccion = world.getObjects(htmlIni.class);
                    htmlIni = (htmlIni)(correccion.get(0));
                    htmlIni.acomoda();
                }
                if(tag.equals("htmlFin"))
                {
                    correccion = world.getObjects(htmlFin.class);
                    htmlFin = (htmlFin)(correccion.get(0));
                    htmlFin.acomoda();
                }
                if(tag.equals("headIni"))
                {
                    correccion = world.getObjects(headIni.class);
                    headIni = (headIni)(correccion.get(0));
                    headIni.acomoda();
                }
                if(tag.equals("headFin"))
                {
                    correccion = world.getObjects(headFin.class);
                    headFin = (headFin)(correccion.get(0));
                    headFin.acomoda();
                }
                if(tag.equals("bodyIni"))
                {
                    correccion = world.getObjects(bodyIni.class);
                    bodyIni = (bodyIni)(correccion.get(0));
                    bodyIni.acomoda();
                }
                if(tag.equals("bodyFin"))
                {
                    correccion = world.getObjects(bodyFin.class);
                    bodyFin = (bodyFin)(correccion.get(0));
                    bodyFin.acomoda();
                }
                if(tag.equals("texto"))
                {
                    correccion = world.getObjects(texto.class);
                    texto = (texto)(correccion.get(0));
                    texto.acomoda();
                }
                if(tag.equals("br"))
                {
                    correccion = world.getObjects(br.class);
                    br = (br)(correccion.get(0));
                    br.acomoda();
                }
            break;
            case 2: //Correccion para el nivel dos
                if(tag.equals("olFin"))
                {
                    correccion = world.getObjects(olFin.class);
                    olFin = (olFin)(correccion.get(0));
                    olFin.acomoda();
                }
                if(tag.equals("li3"))
                {
                    correccion = world.getObjects(li3.class);
                    li3 = (li3)(correccion.get(0));
                    li3.acomoda();
                }
                if(tag.equals("bodyFin"))
                {
                    correccion = world.getObjects(bodyFin.class);
                    bodyFin = (bodyFin)(correccion.get(0));
                    bodyFin.acomoda();
                }
                if(tag.equals("li1"))
                {
                    correccion = world.getObjects(li1.class);
                    li1 = (li1)(correccion.get(0));
                    li1.acomoda();
                }
                if(tag.equals("olIni"))
                {
                    correccion = world.getObjects(olIni.class);
                    olIni = (olIni)(correccion.get(0));
                    olIni.acomoda();
                }
                if(tag.equals("h1"))
                {
                    correccion = world.getObjects(h1.class);
                    h1 = (h1)(correccion.get(0));
                    h1.acomoda();
                }
                if(tag.equals("bodyIni"))
                {
                    correccion = world.getObjects(bodyIni.class);
                    bodyIni = (bodyIni)(correccion.get(0));
                    bodyIni.acomoda();
                }
                if(tag.equals("li2"))
                {
                    correccion = world.getObjects(li2.class);
                    li2 = (li2)(correccion.get(0));
                    li2.acomoda();
                }
                if(tag.equals("img"))
                {
                    correccion = world.getObjects(img.class);
                    img = (img)(correccion.get(0));
                    img.acomoda();
                }
            break;
            case 3:
               if(tag.equals("input2"))
               {
                    correccion = world.getObjects(input2.class);
                    input2 = (input2)(correccion.get(0));
                    input2.acomoda();
                }
                if(tag.equals("table"))
                {
                    correccion = world.getObjects(table.class);
                    table = (table)(correccion.get(0));
                    table.acomoda();
                }
                if(tag.equals("input3"))
                {
                    correccion = world.getObjects(input3.class);
                    input3 = (input3)(correccion.get(0));
                    input3.acomoda();
                }
                if(tag.equals("formFin"))
                {
                    correccion = world.getObjects(formFin.class);
                    formFin = (formFin)(correccion.get(0));
                    formFin.acomoda();
                }
                if(tag.equals("li3"))
                {
                    correccion = world.getObjects(li3.class);
                    li3 = (li3)(correccion.get(0));
                    li3.acomoda();
                }
                if(tag.equals("input1"))
                {
                    correccion = world.getObjects(input1.class);
                    input1 = (input1)(correccion.get(0));
                    input1.acomoda();
                }
                if(tag.equals("input4"))
                {
                    correccion = world.getObjects(input4.class);
                    input4 = (input4)(correccion.get(0));
                    input4.acomoda();
                }
                if(tag.equals("formIni"))
                {
                    correccion = world.getObjects(formIni.class);
                    formIni = (formIni)(correccion.get(0));
                    formIni.acomoda();
                }
                if(tag.equals("h1"))
                {
                    correccion = world.getObjects(h1.class);
                    h1 = (h1)(correccion.get(0));
                    h1.acomoda();
                }
            break;
            case 4:
                if(tag.equals("divIni"))
                {
                    correccion = world.getObjects(divIni.class);
                    divIni = (divIni)(correccion.get(0));
                    divIni.acomoda();
                }
                if(tag.equals("span"))
                {
                    correccion = world.getObjects(span.class);
                    span = (span)(correccion.get(0));
                    span.acomoda();
                }
                if(tag.equals("selectIni"))
                {
                    correccion = world.getObjects(selectIni.class);
                    selectIni = (selectIni)(correccion.get(0));
                    selectIni.acomoda();
                }
                if(tag.equals("option1"))
                {
                    correccion = world.getObjects(option1.class);
                    option1 = (option1)(correccion.get(0));
                    option1.acomoda();
                }
                if(tag.equals("option2"))
                {
                    correccion = world.getObjects(option2.class);
                    option2 = (option2)(correccion.get(0));
                    option2.acomoda();
                }
                if(tag.equals("option3"))
                {
                    correccion = world.getObjects(option3.class);
                    option3 = (option3)(correccion.get(0));
                    option3.acomoda();
                }
                if(tag.equals("selectFin"))
                {
                    correccion = world.getObjects(selectFin.class);
                    selectFin = (selectFin)(correccion.get(0));
                    selectFin.acomoda();
                }
                if(tag.equals("divFin"))
                {
                    correccion = world.getObjects(divFin.class);
                    divFin = (divFin)(correccion.get(0));
                    divFin.acomoda();
                }
                break;
            case 5:
                if(tag.equals("texto"))
                {
                    correccion = world.getObjects(texto.class);
                    texto = (texto)(correccion.get(0));
                    texto.acomoda();
                }
                if(tag.equals("iframe"))
                {
                    correccion = world.getObjects(ifram.class);
                    iframe = (ifram)(correccion.get(0));
                    iframe.acomoda();
                }
            break;
        }
    }
}