import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.io.*; //Paquete para la administrasción de archivos

/**
 * Write a description of class Lecciones here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Lecciones extends Actor
{
    //Define en que numero de leccion es la siguente o la anterior 
    private int nivel;
    private int numLeccion = 0;
    private String leccion = "";
    private boolean comienza;
    private String linea;
    private Icon icono;
    private ArrayList lista;
    private Object[] botones = {"Siguiente"};
    
    private String nombreArchivo;
    protected boolean tutoTime = true;
    HtmlWorld world;
    File archivo = null;
    FileReader fr = null;
    BufferedReader br = null;
    int respuesta;
    
    public Lecciones(HtmlWorld w)
    {
        world = w;
        icono  =  new ImageIcon("iconoMundo.png");
        lista = new ArrayList();
        lista.add("Mi primer Html trae para ti los tutoriales");
        seleccionaArchivo();
        cargaLeccionesNivel();
    }

    /**
     * Act - do whatever the Lecciones wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(tutoTime)
        {
            respuesta = JOptionPane.showOptionDialog(null,lista.get(numLeccion),"Tutoriales",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,icono, botones, botones[0]);
            //Object[] valoresPosibles = {"Pedro", "Juan", "Carlos" }; 
            //Object jefe = JOptionPane.showInputDialog(null,leccion,"Tutoriale",JOptionPane.QUESTION_MESSAGE,null,valoresPosibles, valoresPosibles[0]);
            //respuesta = JOptionPane.showConfirmDialog(null,"¿Realmente Desea Salir de Hola Swing?","Confirmar Salida",JOptionPane.YES_NO_OPTION);
            switch(respuesta)
            {
                /** No se puede retroceder en los tutoriales
                case 0: // Si escoge retroceder
                    if(numLeccion == 0)
                    {    
                        numLeccion += 2;    
                    }
                    if(numLeccion > 1)
                    {
                        botones[0] = "Anterior";
                        botones[1] = "Siguiente";                               
                    }           
                    else 
                        if(numLeccion == 1)
                        {
                            botones[0] = "Siguiente";
                            botones[1] = null;
                        }
                    numLeccion-=1;  // Decrementa la leccion             
                break;
                */
                case 0:
                    if(numLeccion < (lista.size()-1))
                    {
                        numLeccion += 1;
                    }
                    else
                        tutoTime = false;
                break;
                default:
                    world.removeObject(this);
                    tutoTime = false;   
            }
        }
       
    }  
    
    public boolean getFinally()
    {
        return tutoTime;
    }
    
    /**
     * Método que se utiliza para saber que archivo se va a abrir es decir en que nivel esta para ver 
     * que tutorial se va a leer 
     */
    public void seleccionaArchivo()
    {
         nivel = world.dameNivel();
         switch(nivel)
         {
             case 2:
                nombreArchivo = "tutorialesDos.txt";
             break;
             case 3:
                nombreArchivo = "tutorialesTres.txt";
             break;
             case 4:
                nombreArchivo = "tutorialesCuatro.txt";
             break;
             case 5:
                nombreArchivo = "tutorialesCinco.txt";
             break;
             default:
                 nombreArchivo = "tutorialesUno.txt";
         }
    }
    
    /**
     *  Abrimos el fichero y creacion de BufferedReader para poder
     *  hacer una lectura comoda (disponer del metodo readLine())
     *  Lectura del fichero linea por linea 
     *  En el finally cerramos el fichero, para asegurarnos que se cierra tanto si todo va bien como si salta 
     *  una excepcion.
     */
    public void cargaLeccionesNivel()
    {             
        try 
        {
            archivo = new File(nombreArchivo);
            fr = new FileReader (archivo);
            br = new BufferedReader(fr);
            
            while((linea=br.readLine())!=null)
            {
                lista.add(linea);
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        finally
        {
            try
            {                    
                if( null != fr )
                {   
                    fr.close();     
                }                  
            }
            catch (Exception e2)
            { 
                e2.printStackTrace();
            }
        }
       
    }
   
}
